org.cpsolver.studentsct.reservation

## Class IndividualReservation

- java.lang.Object
- - org.cpsolver.ifs.assignment.context.AbstractClassWithContext<Request,Enrollment,Reservation.ReservationContext>
  - - org.cpsolver.studentsct.reservation.Reservation
    - - org.cpsolver.studentsct.reservation.IndividualReservation

- All Implemented Interfaces:
    Comparable<Reservation>, AssignmentComparable<Reservation,Request,Enrollment>, CanHoldContext, CanInheritContext<Request,Enrollment,Reservation.ReservationContext>, HasAssignmentContext<Request,Enrollment,Reservation.ReservationContext>
  Direct Known Subclasses:
    GroupReservation, ReservationOverride

      public class IndividualReservation
      extends Reservation

  Individual reservation. A reservation for a particular student (or students).
  Version:
    StudentSct 1.3 (Student Sectioning)
    Copyright (C) 2007 - 2014 Tomáš Müller
    muller@unitime.org
    http://muller.unitime.org
    This library is free software; you can redistribute it and/or modify it under the terms of the GNU Lesser General Public License as published by the Free Software Foundation; either version 3 of the License, or (at your option) any later version.
    This library is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more details.
    You should have received a copy of the GNU Lesser General Public License along with this library; if not see http://www.gnu.org/licenses/.
  Author:
    Tomáš Müller

- - ### Nested Class Summary

    - ### Nested classes/interfaces inherited from class org.cpsolver.studentsct.reservation.Reservation

      `Reservation.ReservationContext`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static boolean` | `DEFAULT_ALLOW_OVERLAP` Overlaps are allowed for individual reservations.
    `static boolean` | `DEFAULT_CAN_ASSIGN_OVER_LIMIT` Individual reservations are the only reservations that can be assigned over the limit.
    `static boolean` | `DEFAULT_MUST_BE_USED` Individual or group reservation must be used (unless it is expired)
    `static int` | `DEFAULT_PRIORITY` Individual reservations are of the top priority

    - ### Fields inherited from interface org.cpsolver.ifs.assignment.context.CanHoldContext

      `sMaxSize`

  - ### Constructor Summary

    Constructors
    Modifier | Constructor and Description
    --- | ---
    `` | `IndividualReservation(long id, Offering offering, Collection<Long> studentIds)` Constructor
    `protected` | `IndividualReservation(long id, Offering offering, int priority, boolean mustBeUsed, boolean canAssignOverLimit, boolean allowOverlap, Collection<Long> studentIds)` Constructor
    `protected` | `IndividualReservation(long id, Offering offering, int priority, boolean mustBeUsed, boolean canAssignOverLimit, boolean allowOverlap, Long... studentIds)` Constructor
    `` | `IndividualReservation(long id, Offering offering, Long... studentIds)` Constructor

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `double` | `getReservationLimit()` Reservation limit == number of students in the reservation
    `Set<Long>` | `getStudentIds()` Students in the reservation
    `boolean` | `isApplicable(Student student, Course course)` Reservation is applicable for all students in the reservation

    - ### Methods inherited from class org.cpsolver.studentsct.reservation.Reservation

      `addConfig, addSection, addSection, areRestrictionsInclusive, canAssignOverLimit, canBatchAssignOverLimit, canBreakLinkedSections, canEnroll, compareTo, compareTo, createAssignmentContext, getConfigs, getEnrollments, getId, getLimit, getLimit, getLimitCap, getLimitCap, getModel, getOffering, getPriority, getReservedAvailableSpace, getReservedAvailableSpace, getRestrictivity, getSections, getSections, inheritAssignmentContext, isAllowDisabled, isAllowOverlap, isApplicable, isExpired, isIncluded, mustBeUsed, mustBeUsedIgnoreExpiration, neverIncluded, setAllowDisabled, setAllowOverlap, setBreakLinkedSections, setCanAssignOverLimit, setExpired, setMustBeUsed, setNeverIncluded, setPriority`

    - ### Methods inherited from class org.cpsolver.ifs.assignment.context.AbstractClassWithContext

      `getAssignmentContextReference, getContext, getContext, setAssignmentContextReference`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### DEFAULT_PRIORITY

          public static final int DEFAULT_PRIORITY

      Individual reservations are of the top priority
      See Also:
        Constant Field Values

    - #### DEFAULT_MUST_BE_USED

          public static final boolean DEFAULT_MUST_BE_USED

      Individual or group reservation must be used (unless it is expired)
      See Also:
        Constant Field Values

    - #### DEFAULT_CAN_ASSIGN_OVER_LIMIT

          public static final boolean DEFAULT_CAN_ASSIGN_OVER_LIMIT

      Individual reservations are the only reservations that can be assigned over the limit.
      See Also:
        Constant Field Values

    - #### DEFAULT_ALLOW_OVERLAP

          public static final boolean DEFAULT_ALLOW_OVERLAP

      Overlaps are allowed for individual reservations.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### IndividualReservation

          protected IndividualReservation(long id,
                                          Offering offering,
                                          int priority,
                                          boolean mustBeUsed,
                                          boolean canAssignOverLimit,
                                          boolean allowOverlap,
                                          Long... studentIds)

      Constructor
      Parameters:
        `id` - reservation unique id
        `offering` - instructional offering on which the reservation is set
        `priority` - reservation priority
        `mustBeUsed` - must this reservation be used
        `canAssignOverLimit` - can assign over class / configuration / course limit
        `allowOverlap` - does this reservation allow for overlaps
        `studentIds` - one or more students

    - #### IndividualReservation

          public IndividualReservation(long id,
                                       Offering offering,
                                       Long... studentIds)

      Constructor
      Parameters:
        `id` - unique id
        `offering` - offering for which the reservation is
        `studentIds` - one or more students

    - #### IndividualReservation

          protected IndividualReservation(long id,
                                          Offering offering,
                                          int priority,
                                          boolean mustBeUsed,
                                          boolean canAssignOverLimit,
                                          boolean allowOverlap,
                                          Collection<Long> studentIds)

      Constructor
      Parameters:
        `id` - reservation unique id
        `offering` - instructional offering on which the reservation is set
        `priority` - reservation priority
        `mustBeUsed` - must this reservation be used
        `canAssignOverLimit` - can assign over class / configuration / course limit
        `allowOverlap` - does this reservation allow for overlaps
        `studentIds` - one or more students

    - #### IndividualReservation

          public IndividualReservation(long id,
                                       Offering offering,
                                       Collection<Long> studentIds)

      Constructor
      Parameters:
        `id` - unique id
        `offering` - offering for which the reservation is
        `studentIds` - one or more students

  - ### Method Detail

    - #### isApplicable

          public boolean isApplicable(Student student,
                                      Course course)

      Reservation is applicable for all students in the reservation
      Specified by:
        `isApplicable` in class `Reservation`
      Parameters:
        `student` - a student
        `course` - a course
      Returns:
        true if student can use the reservation to get into the course / configuration / section

    - #### getStudentIds

          public Set<Long> getStudentIds()

      Students in the reservation
      Returns:
        set of student ids associated with this reservation

    - #### getReservationLimit

          public double getReservationLimit()

      Reservation limit == number of students in the reservation
      Specified by:
        `getReservationLimit` in class `Reservation`
      Returns:
        reservation limit, -1 for unlimited